<?php

function rrdtool_drupal_system_rrdcreate() {
  return array(
    'cache' => array(
      'flushed' => NULL,
    ),
    'cron' => array(
      'execute' => NULL,
    ),
    'entity' => array(
      'insert' => NULL,
      'update' => NULL,
      'load' => NULL,
    ),
    'mail' => array(
      'sent' => NULL,
    ),
    'menu_link' => array(
      'insert' => NULL,
      'update' => NULL,
      'delete' => NULL,
    ),
    'watchdog' => array(
      'action' => NULL,
      'access denied' => NULL,
      'aggregator' => NULL,
      'content' => NULL,
      'cron' => NULL,
      'error' => NULL,
      'field' => NULL,
      'file' => NULL,
      'file system' => NULL,
      'image' => NULL,
      'locale' => NULL,
      'menu' => NULL,
      'node' => NULL,
      'page not found' => NULL,
      'php' => NULL,
      'profile' => NULL,
      'search' => NULL,
      'system' => NULL,
      'security' => NULL,
      'taxonomy' => NULL,
      'tracker' => NULL,
      'user' => NULL,
      'unknown' => NULL,
    )
  );
}

function rrdtool_drupal_system_rrdgraph() {
  return array(
    'cache' => array(
      'flushed' => array(
        '--start', '%seconds',
        '-Y', '--title=Cache flushed',
        'DEF:flushed=%rrdfile:flushed:AVERAGE',
        'LINE1:flushed#0000FF:hook_flush_caches\\r',
      ),
    ),
    'cron' => array(
      'execute' => array(
        '--start', '%seconds',
        '-Y', '--title=Cron runs',
        'DEF:execute=%rrdfile:execute:AVERAGE',
        'LINE1:execute#0000FF:hook_cron\\r',
      ),
    ),
    'mail' => array(
      'sent' => array(
        '--start', '%seconds',
        '-Y', '--title=Mails sent',
        'DEF:sent=%rrdfile:sent:AVERAGE',
        'LINE1:sent#0000FF:hook_mail\\r',
      ),
    ),
    'entity' => array(
      'edit' => array(
        '--start', '%seconds',
        '-Y', '--title=Entities',
        'DEF:insert=%rrdfile:insert:AVERAGE',
        'DEF:update=%rrdfile:update:AVERAGE',
        'DEF:load=%rrdfile:load:AVERAGE',
        'AREA:insert#00FF00:entity_insert',
        'LINE1:update#FF0000:entity_update',
        'LINE1:load#0000FF:entity_load\\r',
      ),
    ),
    'menu_link' => array(
      'edit' => array(
        '--start', '%seconds',
        '-Y', '--title=Editing menu links',
        'DEF:insert=%rrdfile:insert:AVERAGE',
        'DEF:update=%rrdfile:update:AVERAGE',
        'DEF:delete=%rrdfile:delete:AVERAGE',
        'AREA:insert#00FF00:menu_link_insert',
        'LINE1:update#FF0000:menu_link_update',
        'LINE1:delete#0000FF:menu_link_delete\\r',
      ),
    ),
    'watchdog' => array(
      'content' => array(
        '--start', '%seconds',
        '-Y', '--title=Content logs',
        'DEF:node=%rrdfile:node:AVERAGE',
        'DEF:content=%rrdfile:content:AVERAGE',
        'DEF:taxonomy=%rrdfile:taxonomy:AVERAGE',
        'DEF:user=%rrdfile:user:AVERAGE',
        'DEF:profile=%rrdfile:profile:AVERAGE',
        'DEF:tracker=%rrdfile:tracker:AVERAGE',
        'LINE1:node#00FF00:node',
        'LINE1:content#0000FF:content',
        'LINE1:taxonomy#FF0000:taxonomy\\r',
        'LINE1:user#FF00FF:user',
        'LINE1:profile#00FFFF:profile',
        'LINE1:tracker#FFFF00:tracker\\r',
      ),
      'error' => array(
        '--start', '%seconds',
        '-Y', '--title=Error logs',
        'DEF:page_not_found=%rrdfile:page_not_found:AVERAGE',
        'DEF:access_denied=%rrdfile:access_denied:AVERAGE',
        'DEF:php=%rrdfile:php:AVERAGE',
        'DEF:unknown=%rrdfile:unknown:AVERAGE',
        'LINE1:page_not_found#00FF00:page not found',
        'LINE1:access_denied#0000FF:access denied',
        'LINE1:php#FF0000:php',
        'LINE1:unknown#FF00FF:unknown\\r',
      ),
      'system' => array(
        '--start', '%seconds',
        '-Y', '--title=System logs',
        'DEF:system=%rrdfile:system:AVERAGE',
        'DEF:cron=%rrdfile:cron:AVERAGE',
        'DEF:menu=%rrdfile:menu:AVERAGE',
        'DEF:action=%rrdfile:action:AVERAGE',
        'LINE1:system#00FF00:system',
        'LINE1:cron#0000FF:cron',
        'LINE1:menu#FF0000:menu',
        'LINE1:action#FF00FF:action\\r',
      ),
      'other' => array(
        '--start', '%seconds',
        '-Y', '--title=Other logs',
        'DEF:field=%rrdfile:field:AVERAGE',
        'DEF:file=%rrdfile:file:AVERAGE',
        'DEF:file_system=%rrdfile:file_system:AVERAGE',
        'DEF:image=%rrdfile:image:AVERAGE',
        'DEF:locale=%rrdfile:locale:AVERAGE',
        'DEF:security=%rrdfile:security:AVERAGE',
        'DEF:search=%rrdfile:search:AVERAGE',
        'LINE1:field#00FF00:field',
        'LINE1:file#0000FF:file',
        'LINE1:file_system#FF0000:file system\\r',
        'LINE1:image#FF00FF:image',
        'LINE1:locale#00FFFF:locale',
        'LINE1:security#FFFF00:security',
        'LINE1:search#DADA00:search\\r',
      ),
    ),
  );
}

/**
 * Hook into hook_flush_caches.
 */
function rrdtool_drupal_flush_caches() {
  rrdtool_monitors_increment('cache', 'flushed');
}

/**
 * Hook into hook_cron.
 */
function rrdtool_drupal_cron() {
  rrdtool_monitors_increment('cron', 'execute');
}

/**
 * Hook into hook_mail.
 */
function rrdtool_drupal_mail_alter(&$message) {
  rrdtool_monitors_increment('mail', 'sent');
}

/**
 * Hook into hook_entity_load.
 */
function rrdtool_drupal_entity_load($entity, $type) {
  rrdtool_monitors_increment('entity', 'load');
}

/**
 * Hook into hook_entity_insert.
 */
function rrdtool_drupal_entity_insert($entity, $type) {
  rrdtool_monitors_increment('entity', 'insert');
}

/**
 * Hook into hook_entity_update.
 */
function rrdtool_drupal_entity_update($entity, $type) {
  rrdtool_monitors_increment('entity', 'update');
}

/**
 * Hook into hook_menu_link_insert.
 */
function rrdtool_drupal_menu_link_insert($link) {
  rrdtool_monitors_increment('menu_link', 'insert');
}

/**
 * Hook into hook_menu_link_update.
 */
function rrdtool_drupal_menu_link_update($link) {
  rrdtool_monitors_increment('menu_link', 'update');
}

/**
 * Hook into hook_menu_link_delete.
 */
function rrdtool_drupal_menu_link_delete($link) {
  rrdtool_monitors_increment('menu_link', 'delete');
}

/**
 * Log statistics from core watchdog.
 */
function rrdtool_drupal_watchdog(array $log_entry) {
  $rrds = rrdtool_drupal_rrdcreate();
  $key = (array_key_exists($log_entry['type'], $rrds['system']['definition']['watchdog'])) ? $log_entry['type'] : 'unknown';
  rrdtool_monitors_increment('watchdog', $key);
}

