<?php

function rrdtool_drupal_taxonomy_rrdcreate() {
  return array(
    'taxonomy_vocabulary' => array(
      'insert' => NULL,
      'update' => NULL,
      'load' => NULL,
      'delete' => NULL,
    ),
    'taxonomy_term' => array(
      'presave' => NULL,
      'insert' => NULL,
      'update' => NULL,
      'load' => NULL,
      'delete' => NULL,
    ),
  );
}

function rrdtool_drupal_taxonomy_rrdgraph() {
  return array(
    'taxonomy_vocabulary' => array(
      'view' => array(
        '--start', '%seconds',
        '-Y', '--title=Loaded vocabularies',
        'DEF:load=%rrdfile:load:AVERAGE',
        'AREA:load#00FF00:taxonomy_vocabulary_load\\r',
      ),
      'edit' => array(
        '--start', '%seconds',
        '-Y', '--title=Editing vocabularies',
        'DEF:insert=%rrdfile:insert:AVERAGE',
        'DEF:update=%rrdfile:update:AVERAGE',
        'DEF:delete=%rrdfile:delete:AVERAGE',
        'AREA:insert#00FF00:taxonomy_vocabulary_insert',
        'LINE1:update#FF0000:taxonomy_vocabulary_update',
        'LINE1:delete#0000FF:taxonomy_vocabulary_delete\\r',
      ),
    ),
    'taxonomy_term' => array(
      'view' => array(
        '--start', '%seconds',
        '-Y', '--title=Loaded terms',
        'DEF:load=%rrdfile:load:AVERAGE',
        'AREA:load#00FF00:taxonomy_term_load\\r',
      ),
      'edit' => array(
        '--start', '%seconds',
        '-Y', '--title=Editing terms',
        'DEF:insert=%rrdfile:insert:AVERAGE',
        'DEF:update=%rrdfile:update:AVERAGE',
        'DEF:delete=%rrdfile:delete:AVERAGE',
        'AREA:insert#00FF00:taxonomy_term_insert',
        'LINE1:update#FF0000:taxonomy_term_update',
        'LINE1:delete#0000FF:taxonomy_term_delete\\r',
      ),
    ),
  );
}


/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_vocabulary_load($vocabulary) {
  rrdtool_monitors_increment('taxonomy_vocabulary', 'load');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_vocabulary_insert($vocabulary) {
  rrdtool_monitors_increment('taxonomy_vocabulary', 'insert');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_vocabulary_update($vocabulary) {
  rrdtool_monitors_increment('taxonomy_vocabulary', 'update');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_vocabulary_delete($vocabulary) {
  rrdtool_monitors_increment('taxonomy_vocabulary', 'delete');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_term_presave($term) {
  rrdtool_monitors_increment('taxonomy_term', 'presave');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_term_load($term) {
  rrdtool_monitors_increment('taxonomy_term', 'load');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_term_insert($term) {
  rrdtool_monitors_increment('taxonomy_term', 'insert');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_term_update($term) {
  rrdtool_monitors_increment('taxonomy_term', 'update');
}

/**
 * Hook into taxonomy api.
 */
function rrdtool_drupal_taxonomy_term_delete($term) {
  rrdtool_monitors_increment('taxonomy_term', 'delete');
}

